﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interactivity;
using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Controls.Cells;

namespace SyncfusionGDC
{
    class GDCBehaviour : Behavior<GridDataControl>
    {
        protected override void OnAttached()
        {
            this.AssociatedObject.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AssociatedObject_PreviewMouseDown);
        }

        void AssociatedObject_PreviewMouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            RowColumnIndex rci = this.AssociatedObject.Model.Grid.PointToCellRowColumnIndex(e);
            if (rci.RowIndex > 0 && rci.ColumnIndex > 0)
            {
                GridDataStyleInfo style = this.AssociatedObject.Model[rci.RowIndex, rci.ColumnIndex] as GridDataStyleInfo;
                if (style != null && style.CellIdentity != null && style.CellIdentity.Column != null
                    && style.CellIdentity.TableCellType == GridDataTableCellType.RecordCell
                    && style.CellType == "GridDataBoundTemplate")
                {
                    this.AssociatedObject.Model.CurrencyManager.CurrentCell.MoveTo(rci);
                }
            }
        }
    }
}
